#include <io.h>
#include <7seg.h>
#include <delay.h>

unsigned char
number[4], 
ch[12] = {
        0xFA,     //0
        0x82,     //1
        0xB9,     //2
        0xAB,     //3 
        0xC3,     //4 
        0x6B,     //5 
        0x7B,     //6
        0xA2,     //7 
        0xFB,     //8
        0xEB,     //9 
        0x00,     //blank   
        0x01      //-
                };

/****************************************************************************/
/*  : RefreshDisplay                                                     */
/*  :                                         */
/* () :                                                         */
/*   :                                               */
/****************************************************************************/

void RefreshDisplay()
{ 
 CHR_PORT=~ch[number[0]];
 SBI(NUM_PORT,NUM_1);
 delay_us(LED_delay);
 CBI(NUM_PORT,NUM_1); 
 
 CHR_PORT=~ch[number[1]];
 SBI(NUM_PORT,NUM_2);
 delay_us(LED_delay);
 CBI(NUM_PORT,NUM_2);
 
 CHR_PORT=~ch[number[2]];
 SBI(NUM_PORT,NUM_3);
 delay_us(LED_delay);
 CBI(NUM_PORT,NUM_3);
 
 CHR_PORT=~ch[number[3]];
 SBI(NUM_PORT,NUM_4);
 delay_us(LED_delay);
 CBI(NUM_PORT,NUM_4);
}

/****************************************************************************/
/*  : PrepareData                                                        */
/*  :                                        */
/* () :  , /                                  */
/*   :                                               */
/****************************************************************************/

void PrepareData(unsigned int rpm)
{
 unsigned int r; 
 unsigned char i;  
 
 #asm("cli");
 
 r=rpm;
     
      for(i=0; i<4; i++)
      {
       number[3-i]=rpm%10;
       rpm/=10;
      }
      // 
      if(r<10)
      {
       number[0]=10;
       number[1]=10;
       number[2]=10;
       goto exit;
      }
      
      if((r>=10)&(r<100))
      {
       number[0]=10;
       number[1]=10;
       goto exit;       
      }
      
      if((r>=100)&(r<1000))
      {
       number[0]=10;
       goto exit;              
      }
      exit:
#asm ("sei");    
}