#include <io.h>
#include <7seg.h>

#define START_TIMER           TCCR1B=0x02
#define STOP_TIMER            TCCR1B=0x00 
#define TIMER                 (TCNT1L+(TCNT1H<<8))
#define CLR_TIMER_RPM         TCNT1H=0;TCNT1L=0
#define NO_PULSES_INTERVAL    50000

bit
start;

long 
data;

void initdev()
{
 DDRB=0xFF;
 DDRD=0x7B;
 
 PORTB=0x00;
 PORTD=0x04;
 
 MCUCR=0x00;
 GIMSK=0x40;
 
 TCCR1B=0x02; 
 
}

int conv(unsigned int len_imp)
{
 float f;
 int tmp;
 if(len_imp==0) return 0;  
 f=((float)1000000)/len_imp; 
 f/=2;        
 f*=60;
 tmp=f;
 tmp/=50;
 tmp*=50;
   
   if(tmp<600)
     return 0;  
 
 return tmp;          
}

void main()
{
 unsigned int 
 tmp[3];
 
 unsigned char
 i=0;
 
 initdev();
 
 #asm ("sei");
 
     while (1)
  {
      if(start)
        {  
         tmp[i]=conv(data);       
         if(i)
           {
            i=0;
              if(tmp[0]!=tmp[1])
               {           
                PrepareData(tmp[1]);              
                 }
               }
               
         i++;                     
         RefreshDisplay();
           }
     }     
  }

interrupt [EXT_INT0] void ext_int0_isr(void)
{
 static bit 
 process;  
 
 static unsigned char 
 cnt;

 static unsigned int
 len[4];
 
  if(TIFR&0x80)
    {
     start=0;     
     SBI(TIFR,TOV1);
     process=0;     
     NUM_PORT=ALL_NUM;
     CHR_PORT=~(0x01);
    }
 
  if(!process)
    {
    START_TIMER;
    CLR_TIMER_RPM;    
    process=1;
       }
 else 
    {
     switch(cnt)
           {
            case 0:
            STOP_TIMER;      
            len[0]=TIMER;     
            process=0;
            cnt++;
            break;
      
            case 1:
            STOP_TIMER;
            len[1]=TIMER;
            if((len[1] < (len[0]+30)) && (len[1] > (len[0]-30)))
              {
               cnt++; 
                }
            else
              {
               cnt=0; 
                }
            process=0;
            break;
            
            case 2:
            STOP_TIMER;
            len[2]=TIMER;
            if((len[2] < (len[1]+30)) && (len[2] > (len[1]-30)))
              {
               cnt=10; 
                }
            else
              {
               cnt=0; 
                }
            process=0;
            break;
            
            default:break;
                }
                
     if(cnt==10)
       {
        data=((long)len[0]+(long)len[1]+(long)len[2])/3;
        cnt=0;
        start=1;        
          }
        }             
}
